/* eslint-disable array-callback-return */
export function initialiseControls(controls: any) {
  Object.keys(controls).map((detector) => {
    if (!(detector in controls)) return null;

    Object.keys(controls[detector]).map((controlType) => {
      if (!(controlType in controls[detector])) return;

      if (controlType === "checkbox") {
        const controlId = `${detector}_${controlType}`;
        const labelId = `${detector}_${controlType}_label`;
        controls[detector][controlType] = document.getElementById(controlId);
        controls[detector].label[controlType] =
          document.getElementById(labelId);
        return;
      }

      if (controlType === "slider") {
        Object.keys(controls[detector][controlType]).map((sliderType) => {
          if (!(sliderType in controls[detector][controlType])) return;

          const controlId = `${detector}_${controlType}_${sliderType}`;
          const labelId = `${controlId}_label`;

          const slider: any = document.getElementById(controlId);
          const label = document.getElementById(labelId);
          if (label && slider) {
            label.innerHTML = slider.value;
            slider.oninput = () => {
              label.innerHTML = slider.value;
            };
          }

          controls[detector][controlType][sliderType] = slider;
          controls[detector].label[sliderType] = label;
        });
        return;
      }
    });
  });
}
